let fs = require('fs')
  , inquirer = require('inquirer')
  , ora = require('ora')
  , cmd = require('child_process')

  , mode = process.argv.splice(2).shift()
  , modes = { 'dist': 'dist', 'build': 'build', 'publish': 'dist' }
  , modules = fs.readdirSync('./src').filter(name => name.indexOf('.') === -1)
  ;

inquirer.prompt([{
  type: 'checkbox',
  name: 'modules',
  message: '选择要编译的模块 < 全选(a)/反选(i) >:',
  choices: modules,
  default: []
}]).then(function (answers) {
  let ms = answers.modules.join(',')
    , spinner = ora(`running ${mode} for product ==> ${ms}`)
    ;
  if (ms.length) {
    spinner.start();
    cmd.exec(`npm run ${modes[mode]}:runner -m ${ms}`, function(err, stdout, stderr){
      if (err) {
        console.error(err);
      } else {
        if (mode === 'publish') {
          cmd.exec(`gulp upload -m ${ms}`, function(err, stdout, stderr) {
            if (err) {
              console.error(err);
            }
          });
        }
        spinner.stop();
      }
    });
  } else {
    throw console.error('没有选择编译模块');
  }
});
